<?php
/**
 * @package	    UpdateSiteFix
 * @copyright	Copyright (c)2016 Nicholas K. Dionysopoulos / AkeebaBackup.com
 * @license	    GNU General Public License version 3 or later
 */

defined('_JEXEC') or die;

/**
 * Update site fixer for Packages
 */
class USFComponents extends USFAbstract
{
	protected $extensionType = 'component';

	protected $root = JPATH_ADMINISTRATOR;

	protected $subdir = '/components';

	protected $prefix = 'com_';

	protected $clientId = null;

	public function scan()
	{
		JLoader::import('joomla.filesystem.folder');

		$path = $this->root . '/' . $this->subdir;

		$updateSites = array();

		try
		{
			$dh = new DirectoryIterator($path);
		}
		catch (Exception $e)
		{
			return $updateSites;
		}

		foreach ($dh as $dir)
		{
			if (!$dir->isDir())
			{
				continue;
			}

			if ($dir->isDot())
			{
				continue;
			}

			$dirPath = $dir->getPathname();
			$baseNameDirPath = $dir->getBasename();

			// Parse all XML files
			try
			{
				$dh2 = new DirectoryIterator($dirPath);
			}
			catch (Exception $e)
			{
				continue;
			}

			foreach ($dh2 as $file)
			{
				if (!$file->isFile())
				{
					continue;
				}

				$filePath = $file->getPathname();

				if (substr($filePath, -4) != '.xml')
				{
					continue;
				}

				$element = $baseNameDirPath;

				try
				{
					$moreUpdateSites = $this->parseManifest($filePath, $element, $this->extensionType, $this->clientId, null);
				}
				catch (Exception $e)
				{
					$moreUpdateSites = array();
				}

				if (is_array($moreUpdateSites) && count($moreUpdateSites))
				{
					$updateSites = array_merge($updateSites, $moreUpdateSites);
				}
			}
		}

		return $updateSites;
	}
}