<?php
/**
 * @package	    UpdateSiteFix
 * @copyright	Copyright (c)2016 Nicholas K. Dionysopoulos / AkeebaBackup.com
 * @license	    GNU General Public License version 3 or later
 */

defined('_JEXEC') or die;

/**
 * Update site fixer for Packages
 */
class USFPackages extends USFAbstract
{
	protected $extensionType = 'package';

	protected $subdirectory = 'packages';

	public function scan()
	{
		JLoader::import('joomla.filesystem.folder');

		$path = JPATH_ADMINISTRATOR . '/manifests/' . $this->subdirectory;

		$updateSites = array();

		try
		{
			$dh = new DirectoryIterator($path);
		}
		catch (Exception $e)
		{
			return $updateSites;
		}

		foreach ($dh as $file)
		{
			if (!$file->isFile())
			{
				continue;
			}

			$filePath = $file->getPathname();

			if (substr($filePath, -4) != '.xml')
			{
				continue;
			}

			// Package extensions: element = basename minus .xml (pkg_foo.xml => pkg_foo)
			$element         = strtolower($file->getBasename('.xml'));

			try
			{
				// The last parameter tells it to assume extension ID 700 (Joomla!) for any packages I don't know how to handle
				$moreUpdateSites = $this->parseManifest($filePath, $element, $this->extensionType, null, null, 700);
			}
			catch (Exception $e)
			{
				$moreUpdateSites = array();
			}

			if (is_array($moreUpdateSites) && count($moreUpdateSites))
			{
				$updateSites = array_merge($updateSites, $moreUpdateSites);
			}
		}

		return $updateSites;
	}
}