<?php
/**
 * @package	    UpdateSiteFix
 * @copyright	Copyright (c)2016 Nicholas K. Dionysopoulos / AkeebaBackup.com
 * @license	    GNU General Public License version 3 or later
 */

defined('_JEXEC') or die;

/**
 * Update site fixer for Packages
 */
class USFPlugins extends USFAbstract
{
	protected $extensionType = 'plugin';

	protected $root = JPATH_SITE;

	protected $subdir = '/plugins';

	public function scan()
	{
		JLoader::import('joomla.filesystem.folder');

		$path = $this->root . '/' . $this->subdir;

		$updateSites = array();

		try
		{
			$dh = new DirectoryIterator($path);
		}
		catch (Exception $e)
		{
			return $updateSites;
		}

		foreach ($dh as $dir)
		{
			if (!$dir->isDir())
			{
				continue;
			}

			if ($dir->isDot())
			{
				continue;
			}

			$folderPath = $dir->getPathname();
			$folder = $dir->getBasename();

			// Loop all plugins
			try
			{
				$dhPlugins = new DirectoryIterator($folderPath);
			}
			catch (Exception $e)
			{
				continue;
			}

			foreach ($dhPlugins as $pluginDir)
			{
				if (!$pluginDir->isDir())
				{
					continue;
				}

				if ($pluginDir->isDot())
				{
					continue;
				}

				$pluginPath = $pluginDir->getPathname();
				$plugin = $pluginDir->getBasename();

				// Parse all XML files
				try
				{
					$dh2 = new DirectoryIterator($pluginPath);
				}
				catch (Exception $e)
				{
					continue;
				}

				foreach ($dh2 as $file)
				{
					if (!$file->isFile())
					{
						continue;
					}

					$filePath = $file->getPathname();

					if (substr($filePath, -4) != '.xml')
					{
						continue;
					}

					try
					{
						$moreUpdateSites = $this->parseManifest($filePath, $plugin, $this->extensionType, null, $folder);
					}
					catch (Exception $e)
					{
						$moreUpdateSites = array();
					}

					if (is_array($moreUpdateSites) && count($moreUpdateSites))
					{
						$updateSites = array_merge($updateSites, $moreUpdateSites);
					}
				}
			}
		}

		return $updateSites;
	}
}