<?php
/**
 * @package	    UpdateSiteFix
 * @copyright	Copyright (c)2016 Nicholas K. Dionysopoulos / AkeebaBackup.com
 * @license	    GNU General Public License version 3 or later
 */

class Com_UpdatesitefixInstallerScript
{
	/**
	 * Runs after install, update or discover_update. In other words, it executes after Joomla! has finished installing
	 * or updating your component. This is the last chance you've got to perform any additional installations, clean-up,
	 * database updates and similar housekeeping functions.
	 *
	 * @param   string     $type   install, update or discover_update
	 * @param   JInstaller $parent Parent object
	 */
	public function postflight($type, $parent)
	{
		require_once JPATH_ADMINISTRATOR . '/components/com_updatesitefix/models/fixer.php';
		$fixer = new UpdateSiteFixer();

		$detectedSites = $fixer->discoverUpdateSites();
		$appliedSites = $fixer->applyUpdateSites($detectedSites);

?>
<h3>
	Fix Update Sites
</h3>
<p class="alert">
	<strong>IMPORTANT!</strong>
	If you are using Professional (paid) versions of Akeeba extensions you must go to each extension's main page and click on
	the &quot;Reload Update Information&quot; button for updates to work.
</p>
<p>
	<strong>Total detected update sites:</strong> <?php echo count($detectedSites); ?>
	<br/>
	<strong>Total applied update sites:</strong> <?php echo $appliedSites; ?>
</p>
<p>
	You can now uninstall this component.
</p>
<?php
	}
}